C
C     This is the driver for the matrix inversion program.
C     The program goes through the following steps: 
C     1.  Fills a 5 X 5 matrix with random real numbers 
c     2.  WRITEs out the matrix to the screen
c     3.  Calls a subroutine to INVERT the matrix
c     4.  WRITEs out the inverse to the screen
c     5.  WRITEs out the proof of the inversion     
c
c aslhflskadfhkljsdfa

      PROGRAM inversion

      real*4      a(20,20), origA(20,20), indx(20)
      Real*4      invA(20,20),sum, idmatrix(20,20)
      REAL*4      xx4,yy4

      INTEGER*4   np, n

      PARAMETER (np=20)

      n = 5 

      do 11 i=1,n         ! Step1:  Initialize the matrix by calling RANDOM
          do 12 j = 1,n
              call RANDOM(a(i,j))  
 12       continue
 11   continue


      write (*,'(1x,a)') 'The matrix is:'

      DO 21 i=1,n         ! Step 2:  WRITE out the matrix
          do 23 j=1,n
              origA(i,j) = a(i,j)
              WRITE (*,22) a(i,j)
 23       continue
 22       format(f8.3,\)
          WRITE(*,*)
 21   CONTINUE

      WRITE(*,*)
      
c
c     Step 3:  Call the INVERT routine
c
      
      CALL invert(a, invA, indx, np, n)

      
      WRITE(*,'(1x,a)') 'Hit ENTER to continue...'
      read(*,*)      
      
c
c     Step 4:  WRITE out the invers to the screen
c
      
      WRITE(*,'(1x,a)') 'The inverse of this matrix is:'
      DO 41 i=1,n
          do 43 j=1,n
              WRITE (*,42) invA(i,j)
 43       continue
 42       format(f8.3,\)
          WRITE(*,*)
 41   continue 
  
      WRITE (*,*)
      
      
      WRITE(*,'(1x,a)') 'Hit ENTER to continue...'
      read(*,*)
      
c
c     Step 5:  WRITE the prrof of the inversion
c        
      
      WRITE(*,'(1x,a)') 'We can verify this inversion as follows:'      
      
      do 51 i=1,n
          do 55 k=1,n
              sum = 0.
              do 53 j=1,n-1
                  sum = ( origA(i,j) * invA(j,k) ) + sum
 53           continue
              sum = (origA(i,n) * invA(n,k)) + sum
              idmatrix(i,k) = sum
 55       continue
 51   continue   

      CALL WRITEMATRIX(origA, invA, idmatrix, n, np)
      

 999  END

